import { TNSParticleAPI, TNSParticleDevice, TNSParticleEvent, TNSParticleLoginOptions } from "./particle.common";
export declare class Particle implements TNSParticleAPI {
    eventIds: Map<string, (event: TNSParticleEvent) => void>;
    private tokens;
    private currentProduct;
    constructor();
    private initWorkerIfNeeded;
    private initEventWorkerIfNeeded;
    login(options: TNSParticleLoginOptions): Promise<void>;
    loginWithToken(token: string, productId: number): void;
    setOAuthConfig(id: string, secret: string): void;
    logout(): void;
    publish(name: string, data: string, isPrivate: boolean, ttl: number, productId: number): Promise<void>;
    subscribe(prefix: string, eventHandler: (event: TNSParticleEvent) => void, productId: number): void;
    unsubscribe(prefix: string, productId: number): void;
    listDevices(productId: number): Promise<Array<TNSParticleDevice>>;
    isAuthenticated(): boolean;
    accessToken(): string;
    startDeviceSetupWizard(productId: number): Promise<boolean>;
    getDeviceSetupCustomizer(): any;
    private renameDevice;
    private unclaimDevice;
    private callFunction;
    private getVariable;
    private subscribeDevice;
    private unsubscribeDevice;
    authIfNeeded(productId: number): void;
}
