import { TNSParticleAPI, TNSParticleDevice, TNSParticleEvent, TNSParticleLoginOptions } from "./particle.common";
export declare class Particle implements TNSParticleAPI {
    private wizardDelegate;
    private eventIds;
    private tokens;
    private currentProduct;
    constructor();
    login(options: TNSParticleLoginOptions): Promise<void>;
    loginWithToken(token: string, productId: number): void;
    setOAuthConfig(id: string, secret: string): void;
    logout(): void;
    isAuthenticated(): boolean;
    accessToken(): string;
    listDevices(productId: number): Promise<Array<TNSParticleDevice>>;
    publish(name: string, data: string, isPrivate: boolean, ttl: number, productId: number): Promise<void>;
    subscribe(prefix: string, eventHandler: (event: TNSParticleEvent) => void, productId: number): void;
    unsubscribe(prefix: string, productId: number): void;
    startDeviceSetupWizard(productId: number): Promise<boolean>;
    authIfNeeded(productId: number): void;
    getDeviceSetupCustomizer(): any;
}
